// Generated by CoffeeScript 1.12.7
(function() {
  var AggregateExpression, AllTrue, AnyTrue, Avg, Count, Exception, Expression, GeometricMean, Max, Median, Min, Mode, PopulationStdDev, PopulationVariance, Product, Quantity, StdDev, Sum, Variance, allTrue, anyTrue, build, convertAllUnits, doAddition, doMultiplication, getValuesFromQuantities, greaterThan, hasOnlyQuantities, hasSomeQuantities, lessThan, medianOfNumbers, numerical_sort, processQuantities, ref, ref1, ref2, removeNulls, typeIsArray,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty,
    indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  Expression = require('./expression').Expression;

  ref = require('../util/util'), typeIsArray = ref.typeIsArray, allTrue = ref.allTrue, anyTrue = ref.anyTrue, removeNulls = ref.removeNulls, numerical_sort = ref.numerical_sort;

  build = require('./builder').build;

  Exception = require('../datatypes/exception').Exception;

  ref1 = require('../util/comparison'), greaterThan = ref1.greaterThan, lessThan = ref1.lessThan;

  ref2 = require('../datatypes/quantity'), Quantity = ref2.Quantity, doAddition = ref2.doAddition, doMultiplication = ref2.doMultiplication;

  AggregateExpression = (function(superClass) {
    extend(AggregateExpression, superClass);

    function AggregateExpression(json) {
      AggregateExpression.__super__.constructor.apply(this, arguments);
      this.source = build(json.source);
    }

    return AggregateExpression;

  })(Expression);

  module.exports.Count = Count = (function(superClass) {
    extend(Count, superClass);

    function Count(json) {
      Count.__super__.constructor.apply(this, arguments);
    }

    Count.prototype.exec = function(ctx) {
      var items;
      items = this.source.execute(ctx);
      if (!typeIsArray(items)) {
        return null;
      }
      return removeNulls(items).length;
    };

    return Count;

  })(AggregateExpression);

  module.exports.Sum = Sum = (function(superClass) {
    extend(Sum, superClass);

    function Sum(json) {
      Sum.__super__.constructor.apply(this, arguments);
    }

    Sum.prototype.exec = function(ctx) {
      var e, items, sum, values;
      items = this.source.execute(ctx);
      if (!typeIsArray(items)) {
        return null;
      }
      try {
        items = processQuantities(items);
      } catch (error) {
        e = error;
        return null;
      }
      if (!(items.length > 0)) {
        return null;
      }
      if (hasOnlyQuantities(items)) {
        values = getValuesFromQuantities(items);
        sum = values.reduce(function(x, y) {
          return x + y;
        });
        return new Quantity(sum, items[0].unit);
      } else {
        return items.reduce(function(x, y) {
          return x + y;
        });
      }
    };

    return Sum;

  })(AggregateExpression);

  module.exports.Min = Min = (function(superClass) {
    extend(Min, superClass);

    function Min(json) {
      Min.__super__.constructor.apply(this, arguments);
    }

    Min.prototype.exec = function(ctx) {
      var e, element, i, len, list, listWithoutNulls, minimum;
      list = this.source.execute(ctx);
      if (list == null) {
        return null;
      }
      listWithoutNulls = removeNulls(list);
      try {
        processQuantities(list);
      } catch (error) {
        e = error;
        return null;
      }
      if (!(listWithoutNulls.length > 0)) {
        return null;
      }
      minimum = listWithoutNulls[0];
      for (i = 0, len = listWithoutNulls.length; i < len; i++) {
        element = listWithoutNulls[i];
        if (lessThan(element, minimum)) {
          minimum = element;
        }
      }
      return minimum;
    };

    return Min;

  })(AggregateExpression);

  module.exports.Max = Max = (function(superClass) {
    extend(Max, superClass);

    function Max(json) {
      Max.__super__.constructor.apply(this, arguments);
    }

    Max.prototype.exec = function(ctx) {
      var e, element, i, items, len, listWithoutNulls, maximum;
      items = this.source.execute(ctx);
      if (items == null) {
        return null;
      }
      listWithoutNulls = removeNulls(items);
      try {
        processQuantities(items);
      } catch (error) {
        e = error;
        return null;
      }
      if (!(listWithoutNulls.length > 0)) {
        return null;
      }
      maximum = listWithoutNulls[0];
      for (i = 0, len = listWithoutNulls.length; i < len; i++) {
        element = listWithoutNulls[i];
        if (greaterThan(element, maximum)) {
          maximum = element;
        }
      }
      return maximum;
    };

    return Max;

  })(AggregateExpression);

  module.exports.Avg = Avg = (function(superClass) {
    extend(Avg, superClass);

    function Avg(json) {
      Avg.__super__.constructor.apply(this, arguments);
    }

    Avg.prototype.exec = function(ctx) {
      var e, items, sum, values;
      items = this.source.execute(ctx);
      if (!typeIsArray(items)) {
        return null;
      }
      try {
        items = processQuantities(items);
      } catch (error) {
        e = error;
        return null;
      }
      if (items.length === 0) {
        return null;
      }
      if (hasOnlyQuantities(items)) {
        values = getValuesFromQuantities(items);
        sum = values.reduce(function(x, y) {
          return x + y;
        });
        return new Quantity(sum / values.length, items[0].unit);
      } else {
        sum = items.reduce(function(x, y) {
          return x + y;
        });
        return sum / items.length;
      }
    };

    return Avg;

  })(AggregateExpression);

  module.exports.Median = Median = (function(superClass) {
    extend(Median, superClass);

    function Median(json) {
      Median.__super__.constructor.apply(this, arguments);
    }

    Median.prototype.exec = function(ctx) {
      var e, items, median, values;
      items = this.source.execute(ctx);
      if (!typeIsArray(items)) {
        return null;
      }
      if (!(items.length > 0)) {
        return null;
      }
      try {
        items = processQuantities(items);
      } catch (error) {
        e = error;
        return null;
      }
      if (!hasOnlyQuantities(items)) {
        return medianOfNumbers(items);
      }
      values = getValuesFromQuantities(items);
      median = medianOfNumbers(values);
      return new Quantity(median, items[0].unit);
    };

    return Median;

  })(AggregateExpression);

  module.exports.Mode = Mode = (function(superClass) {
    extend(Mode, superClass);

    function Mode(json) {
      Mode.__super__.constructor.apply(this, arguments);
    }

    Mode.prototype.exec = function(ctx) {
      var e, filtered, items, mode, values;
      items = this.source.execute(ctx);
      if (!typeIsArray(items)) {
        return null;
      }
      if (!(items.length > 0)) {
        return null;
      }
      try {
        filtered = processQuantities(items);
      } catch (error) {
        e = error;
        return null;
      }
      if (hasOnlyQuantities(filtered)) {
        values = getValuesFromQuantities(filtered);
        mode = this.mode(values);
        if (mode.length === 1) {
          mode = mode[0];
        }
        return new Quantity(mode, items[0].unit);
      } else {
        mode = this.mode(filtered);
        if (mode.length === 1) {
          return mode[0];
        } else {
          return mode;
        }
      }
    };

    Mode.prototype.mode = function(arr) {
      var cnt, counts, elem, i, len, max, ref3, results;
      max = 0;
      counts = {};
      results = [];
      for (i = 0, len = arr.length; i < len; i++) {
        elem = arr[i];
        cnt = counts[elem] = ((ref3 = counts[elem]) != null ? ref3 : 0) + 1;
        if (cnt === max && indexOf.call(results, elem) < 0) {
          results.push(elem);
        } else if (cnt > max) {
          results = [elem];
          max = cnt;
        }
      }
      return results;
    };

    return Mode;

  })(AggregateExpression);

  module.exports.StdDev = StdDev = (function(superClass) {
    extend(StdDev, superClass);

    function StdDev(json) {
      StdDev.__super__.constructor.apply(this, arguments);
      this.type = "standard_deviation";
    }

    StdDev.prototype.exec = function(ctx) {
      var e, items, stdDev, values;
      items = this.source.execute(ctx);
      if (!typeIsArray(items)) {
        return null;
      }
      try {
        items = processQuantities(items);
      } catch (error) {
        e = error;
        return null;
      }
      if (!(items.length > 0)) {
        return null;
      }
      if (hasOnlyQuantities(items)) {
        values = getValuesFromQuantities(items);
        stdDev = this.standardDeviation(values);
        return new Quantity(stdDev, items[0].unit);
      } else {
        return this.standardDeviation(items);
      }
    };

    StdDev.prototype.standardDeviation = function(list) {
      var val;
      val = this.stats(list);
      if (val) {
        return val[this.type];
      }
    };

    StdDev.prototype.stats = function(list) {
      var i, len, mean, pop_dev, pop_var, sq, std_dev, std_var, sum, sumOfSquares;
      sum = list.reduce(function(x, y) {
        return x + y;
      });
      mean = sum / list.length;
      sumOfSquares = 0;
      for (i = 0, len = list.length; i < len; i++) {
        sq = list[i];
        sumOfSquares += Math.pow(sq - mean, 2);
      }
      std_var = (1 / list.length) * sumOfSquares;
      pop_var = (1 / (list.length - 1)) * sumOfSquares;
      std_dev = Math.sqrt(std_var);
      pop_dev = Math.sqrt(pop_var);
      return {
        standard_variance: std_var,
        population_variance: pop_var,
        standard_deviation: std_dev,
        population_deviation: pop_dev
      };
    };

    return StdDev;

  })(AggregateExpression);

  module.exports.Product = Product = (function(superClass) {
    extend(Product, superClass);

    function Product(json) {
      Product.__super__.constructor.apply(this, arguments);
    }

    Product.prototype.exec = function(ctx) {
      var e, items, product, values;
      items = this.source.execute(ctx);
      if (!typeIsArray(items)) {
        return null;
      }
      try {
        items = processQuantities(items);
      } catch (error) {
        e = error;
        return null;
      }
      if (!(items.length > 0)) {
        return null;
      }
      if (hasOnlyQuantities(items)) {
        values = getValuesFromQuantities(items);
        product = values.reduce(function(x, y) {
          return x * y;
        });
        return new Quantity(product, items[0].unit);
      } else {
        return items.reduce(function(x, y) {
          return x * y;
        });
      }
    };

    return Product;

  })(AggregateExpression);

  module.exports.GeometricMean = GeometricMean = (function(superClass) {
    extend(GeometricMean, superClass);

    function GeometricMean(json) {
      GeometricMean.__super__.constructor.apply(this, arguments);
    }

    GeometricMean.prototype.exec = function(ctx) {
      var e, geoMean, items, product, values;
      items = this.source.execute(ctx);
      if (!typeIsArray(items)) {
        return null;
      }
      try {
        items = processQuantities(items);
      } catch (error) {
        e = error;
        return null;
      }
      if (!(items.length > 0)) {
        return null;
      }
      if (hasOnlyQuantities(items)) {
        values = getValuesFromQuantities(items);
        product = values.reduce(function(x, y) {
          return x * y;
        });
        geoMean = Math.pow(product, 1.0 / items.length);
        return new Quantity(geoMean, items[0].unit);
      } else {
        product = items.reduce(function(x, y) {
          return x * y;
        });
        return Math.pow(product, 1.0 / items.length);
      }
    };

    return GeometricMean;

  })(AggregateExpression);

  module.exports.PopulationStdDev = PopulationStdDev = (function(superClass) {
    extend(PopulationStdDev, superClass);

    function PopulationStdDev(json) {
      PopulationStdDev.__super__.constructor.apply(this, arguments);
      this.type = "population_deviation";
    }

    return PopulationStdDev;

  })(StdDev);

  module.exports.Variance = Variance = (function(superClass) {
    extend(Variance, superClass);

    function Variance(json) {
      Variance.__super__.constructor.apply(this, arguments);
      this.type = "standard_variance";
    }

    return Variance;

  })(StdDev);

  module.exports.PopulationVariance = PopulationVariance = (function(superClass) {
    extend(PopulationVariance, superClass);

    function PopulationVariance(json) {
      PopulationVariance.__super__.constructor.apply(this, arguments);
      this.type = "population_variance";
    }

    return PopulationVariance;

  })(StdDev);

  module.exports.AllTrue = AllTrue = (function(superClass) {
    extend(AllTrue, superClass);

    function AllTrue(json) {
      AllTrue.__super__.constructor.apply(this, arguments);
    }

    AllTrue.prototype.exec = function(ctx) {
      var items;
      items = this.source.execute(ctx);
      return allTrue(items);
    };

    return AllTrue;

  })(AggregateExpression);

  module.exports.AnyTrue = AnyTrue = (function(superClass) {
    extend(AnyTrue, superClass);

    function AnyTrue(json) {
      AnyTrue.__super__.constructor.apply(this, arguments);
    }

    AnyTrue.prototype.exec = function(ctx) {
      var items;
      items = this.source.execute(ctx);
      return anyTrue(items);
    };

    return AnyTrue;

  })(AggregateExpression);

  processQuantities = function(values) {
    values = removeNulls(values);
    if (hasOnlyQuantities(values)) {
      return values = convertAllUnits(values);
    } else if (hasSomeQuantities(values)) {
      throw new Exception("Cannot perform aggregate operations on mixed values of Quantities and non Quantities");
    } else {
      return values;
    }
  };

  getValuesFromQuantities = function(quantities) {
    return quantities.map(function(quantity) {
      return quantity.value;
    });
  };

  hasOnlyQuantities = function(arr) {
    return arr.every(function(x) {
      return x.isQuantity;
    });
  };

  hasSomeQuantities = function(arr) {
    return arr.some(function(x) {
      return x.isQuantity;
    });
  };

  convertAllUnits = function(arr) {
    var converted, i, len, quantity;
    converted = [];
    for (i = 0, len = arr.length; i < len; i++) {
      quantity = arr[i];
      converted.push(quantity.convertUnit(arr[0].unit));
    }
    return converted;
  };

  medianOfNumbers = function(numbers) {
    numbers = numerical_sort(numbers, "asc");
    if (numbers.length % 2 === 1) {
      return numbers[(numbers.length - 1) / 2];
    } else {
      return (numbers[(numbers.length / 2) - 1] + numbers[numbers.length / 2]) / 2;
    }
  };

}).call(this);

//# sourceMappingURL=aggregate.js.map
